/*----- PROTECTED REGION ID(Pie517.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Pie517.cpp
//
// description : C++ source for the Pie517 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Pie517 are implemented in this file.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Pie517.h>
#include <Pie517Class.h>
#include "mymisc.h"

#define NCHANNELS 3
#define USECWAIT  20000

// Commands table
// Full descriptions are available in the PZ214E User Manual
//
// Status and Error
// ERR Pag. 153
// ONT Pag. 176
// OVF Pag. 177
//
// Configuration
// ONL Pag. 174-175
// VCO Pag. 204
// DCO Pag. 145-146
// SVO Pag. 193-194
// TMN,TMX Pag. 197
//
// Moving
// POS Pag. 178
// TSP Pag. 199
// VEL Pag. 205-206
// STP Pag. 190
// HLT Pag. 156
// MOV Pag. 170-171
//
// Reboot
// RBT Pag. 182
//
// Homing
// GOH Pag. 154
// DFH Pag. 146,149
// WPA Pag. 229


/*----- PROTECTED REGION END -----*/	//	Pie517.cpp

/**
 *  Pie517 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//  State         |  Inherited (no method)
//  Status        |  Inherited (no method)
//  Stop          |  stop
//  Reboot        |  reboot
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Position_A  |  Tango::DevDouble	Scalar
//  Position_B  |  Tango::DevDouble	Scalar
//  Position_C  |  Tango::DevDouble	Scalar
//  Volt_A      |  Tango::DevDouble	Scalar
//  Volt_B      |  Tango::DevDouble	Scalar
//  Volt_C      |  Tango::DevDouble	Scalar
//  Velocity_A  |  Tango::DevDouble	Scalar
//  Velocity_B  |  Tango::DevDouble	Scalar
//  Velocity_C  |  Tango::DevDouble	Scalar
//================================================================

namespace Pie517_ns
{
/*----- PROTECTED REGION ID(Pie517::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Pie517::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Pie517::Pie517()
 *	Description : Constructors for a Tango device
 *                implementing the classPie517
 */
//--------------------------------------------------------
Pie517::Pie517(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Pie517::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::constructor_1
}
//--------------------------------------------------------
Pie517::Pie517(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Pie517::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::constructor_2
}
//--------------------------------------------------------
Pie517::Pie517(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Pie517::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Pie517::delete_device()
{
	DEBUG_STREAM << "Pie517::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Pie517::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	//	Delete socket object
	socket->interrupt();
	socket->disconnect();
	delete socket;

	//	Delete device allocated objects

	/*----- PROTECTED REGION END -----*/	//	Pie517::delete_device
	delete[] attr_Position_A_read;
	delete[] attr_Position_B_read;
	delete[] attr_Position_C_read;
	delete[] attr_Volt_A_read;
	delete[] attr_Volt_B_read;
	delete[] attr_Volt_C_read;
	delete[] attr_Velocity_A_read;
	delete[] attr_Velocity_B_read;
	delete[] attr_Velocity_C_read;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Pie517::init_device()
{
	DEBUG_STREAM << "Pie517::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Pie517::init_device_before) ENABLED START -----*/
	

	/*----- PROTECTED REGION END -----*/	//	Pie517::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	attr_Position_A_read = new Tango::DevDouble[1];
	attr_Position_B_read = new Tango::DevDouble[1];
	attr_Position_C_read = new Tango::DevDouble[1];
	attr_Volt_A_read = new Tango::DevDouble[1];
	attr_Volt_B_read = new Tango::DevDouble[1];
	attr_Volt_C_read = new Tango::DevDouble[1];
	attr_Velocity_A_read = new Tango::DevDouble[1];
	attr_Velocity_B_read = new Tango::DevDouble[1];
	attr_Velocity_C_read = new Tango::DevDouble[1];

	/*----- PROTECTED REGION ID(Pie517::init_device) ENABLED START -----*/
	
	//	Initialize device

	initialized = false;
	comm_ok = false;

	socket = new mysocket_ns::MySocket(this, iPAddress, 50000, 200, false);

	/*----- PROTECTED REGION END -----*/	//	Pie517::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Pie517::get_device_property()
{
	/*----- PROTECTED REGION ID(Pie517::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	

	/*----- PROTECTED REGION END -----*/	//	Pie517::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("IPAddress"));
	dev_prop.push_back(Tango::DbDatum("MQ_A"));
	dev_prop.push_back(Tango::DbDatum("MQ_B"));
	dev_prop.push_back(Tango::DbDatum("MQ_C"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Pie517Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Pie517Class	*ds_class =
			(static_cast<Pie517Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize IPAddress from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  iPAddress;
		else {
			//	Try to initialize IPAddress from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  iPAddress;
		}
		//	And try to extract IPAddress value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  iPAddress;

		//	Try to initialize MQ_A from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  mQ_A;
		else {
			//	Try to initialize MQ_A from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  mQ_A;
		}
		//	And try to extract MQ_A value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  mQ_A;

		//	Try to initialize MQ_B from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  mQ_B;
		else {
			//	Try to initialize MQ_B from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  mQ_B;
		}
		//	And try to extract MQ_B value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  mQ_B;

		//	Try to initialize MQ_C from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  mQ_C;
		else {
			//	Try to initialize MQ_C from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  mQ_C;
		}
		//	And try to extract MQ_C value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  mQ_C;

	}

	/*----- PROTECTED REGION ID(Pie517::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Pie517::always_executed_hook()
{
	INFO_STREAM << "Pie517::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Pie517::always_executed_hook) ENABLED START -----*/
	
	stringstream strerror;

	// Slow down things a bit
	// usleep(USECWAIT * 10);

	#ifdef _DBG_COMM
		cout << "AEH entering: comm_ok = " << (comm_ok?"true":"false") << endl;
	#endif /* _DBG_COM */

	if (!socket->check_and_reconnect(strerror)) {
			set_state(Tango::FAULT);
			set_status(string("Communication error: ") + strerror.str());
			sleep(1);
			initialized = false;
			comm_ok = false;
			return;
	} comm_ok = true;

	#ifdef _DBG_COMM
		cout << "AEH 0: comm_ok = " << (comm_ok?"true":"false") << endl;
	#endif /* _DBG_COM */

	if (!initialized){
		stringstream cmd2, resp2;
		cmd2 << "*IDN?\n";
		request(cmd2, &resp2);
		if (resp2.str().size() > 0) {
			comm_ok = true;
			set_state(Tango::ON);
			set_status("The device is in ON state.");
		} else {
			comm_ok = false;
			set_state(Tango::FAULT);
			set_status("The device is in FAULT state.");
			return;
		}
	}

	#ifdef _DBG_COMM
		cout << "AEH 1: comm_ok = " << (comm_ok?"true":"false") << endl;
	#endif /* _DBG_COM */

	if (initialized == false && get_state() == Tango::ON) {
		TANGO_WARNING << "Initializing device...";

		// Set ONLINE mode on all piezo channels
		for (int i=1; i<NCHANNELS+1; i++) {
			stringstream cmd;
			cmd << "ONL " << i << " 1\n";
			request(cmd);
		}	

		// Set OPEN-LOOP mode on all piezo channels
		for (char i='A'; i<'D'; i++) {
			stringstream cmd;
			cmd << "SVO " << i << " 0\n";
			request(cmd);
		}

		// Set DRIFT ACTIVATION mode on all piezo channels
		for (char i='A'; i<'D'; i++) {
			stringstream cmd;
			cmd << "DCO " << i << " 1\n";
			request(cmd);
		}

		// Set VELOCITY control to on
		for (char i='A'; i<'D'; i++) {
			stringstream cmd;
			cmd << "VCO " << i << " 1\n";
			request(cmd);
		}

//		// Get movement ranges
//		{
//			stringstream cmd1, resp1, cmd2, resp2, cmd3, resp3, cmd4, resp4;
//			cmd1 << "NLM? A\n";
//			request(cmd1, &resp1);
//			resp1 >> min_Position_X;
//			cmd2 << "PLM? A\n";
//			request(cmd2, &resp2);
//			resp2 >> max_Position_X;
//			cmd3 << "NLM? B\n";
//			request(cmd3, &resp3);
//			resp3 >> min_Position_Y;
//			cmd4 << "PLM? B\n";
//			request(cmd4, &resp4);
//			resp4 >> max_Position_Y;
//		}

		// Done
		initialized = true;
	}

	#ifdef _DBG_COMM
		cout << "AEH leaving: comm_ok = " << (comm_ok?"true":"false") << endl;
	#endif /* _DBG_COM */

	/*----- PROTECTED REGION END -----*/	//	Pie517::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Pie517::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Pie517::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Pie517::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method      : Pie517::write_attr_hardware()
 *	Description : Hardware writing for attributes
 */
//--------------------------------------------------------
void Pie517::write_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Pie517::write_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::write_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Position_A related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Position_A(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Position_A(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Position_A) ENABLED START -----*/

	*attr_Position_A_read = mQ_A[0] * (*attr_Volt_A_read) + mQ_A[1];

	//	Set the attribute value
	attr.set_value(attr_Position_A_read);
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Position_A
}
//--------------------------------------------------------
/**
 *	Write attribute Position_A related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Position_A(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Position_A(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Position_A) ENABLED START -----*/

	stringstream cmd2;
	try {
		cmd2 << "SVA A " << ((w_val - mQ_A[1]) / mQ_A[0]) << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Position_A
}
//--------------------------------------------------------
/**
 *	Read attribute Position_B related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Position_B(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Position_B(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Position_B) ENABLED START -----*/

	*attr_Position_B_read = mQ_B[0] * (*attr_Volt_B_read) + mQ_B[1];

	//	Set the attribute value
	attr.set_value(attr_Position_B_read);
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Position_B
}
//--------------------------------------------------------
/**
 *	Write attribute Position_B related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Position_B(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Position_B(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Position_B) ENABLED START -----*/

	stringstream cmd2;
	try {
		cmd2 << "SVA B " << ((w_val - mQ_B[1]) / mQ_B[0]) << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Position_B
}
//--------------------------------------------------------
/**
 *	Read attribute Position_C related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Position_C(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Position_C(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Position_C) ENABLED START -----*/

	*attr_Position_C_read = mQ_C[0] * (*attr_Volt_C_read) + mQ_C[1];

	//	Set the attribute value
	attr.set_value(attr_Position_C_read);
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Position_C
}
//--------------------------------------------------------
/**
 *	Write attribute Position_C related method
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Position_C(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Position_C(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Position_C) ENABLED START -----*/
	
	stringstream cmd2;
	try {
		cmd2 << "SVA C " << ((w_val - mQ_C[1]) / mQ_C[0]) << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Position_C
}
//--------------------------------------------------------
/**
 *	Read attribute Volt_A related method
 *	Description: Ch A, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Volt_A(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Volt_A(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Volt_A) ENABLED START -----*/
	Tango::DevDouble actualPos;
	stringstream cmd, resp, cmd2;
	cmd << "VOL? 1\n";
	try {
		request(cmd, &resp);
		resp.ignore(2);
		resp >> actualPos;
	} catch(Tango::DevFailed) {
		throw;
	}
	*attr_Volt_A_read = actualPos;
	attr.set_value(attr_Volt_A_read);
	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Volt_A
}
//--------------------------------------------------------
/**
 *	Write attribute Volt_A related method
 *	Description: Ch A, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Volt_A(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Volt_A(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Volt_A) ENABLED START -----*/
	stringstream cmd2;
	try {
		cmd2 << "SVA A " << w_val << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Volt_A
}
//--------------------------------------------------------
/**
 *	Read attribute Volt_B related method
 *	Description: Ch B, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Volt_B(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Volt_B(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Volt_B) ENABLED START -----*/
	Tango::DevDouble actualPos;
	stringstream cmd, resp, cmd2;
	cmd << "VOL? 2\n";
	try {
		request(cmd, &resp);
		resp.ignore(2);
		resp >> actualPos;
	} catch(Tango::DevFailed) {
		throw;
	}
	*attr_Volt_B_read = actualPos;
	attr.set_value(attr_Volt_B_read);
	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Volt_B
}
//--------------------------------------------------------
/**
 *	Write attribute Volt_B related method
 *	Description: Ch B, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Volt_B(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Volt_B(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Volt_B) ENABLED START -----*/
	stringstream cmd2;
	try {
		cmd2 << "SVA B " << w_val << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Volt_B
}
//--------------------------------------------------------
/**
 *	Read attribute Volt_C related method
 *	Description: Ch C, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Volt_C(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Volt_C(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Volt_C) ENABLED START -----*/
	Tango::DevDouble actualPos;
	stringstream cmd, resp, cmd2;
	cmd << "VOL? 3\n";
	try {
		request(cmd, &resp);
		resp.ignore(2);
		resp >> actualPos;
	} catch(Tango::DevFailed) {
		throw;
	}
	*attr_Volt_C_read = actualPos;
	attr.set_value(attr_Volt_C_read);
	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Volt_C
}
//--------------------------------------------------------
/**
 *	Write attribute Volt_C related method
 *	Description: Ch C, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Volt_C(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Volt_C(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Volt_C) ENABLED START -----*/
	stringstream cmd2;
	try {
		cmd2 << "SVA C " << w_val << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Volt_C
}
//--------------------------------------------------------
/**
 *	Read attribute Velocity_A related method
 *	Description: A Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Velocity_A(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Velocity_A(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Velocity_A) ENABLED START -----*/

	stringstream cmd, resp;
	cmd << "VEL? A\n";
	try {
		request(cmd, &resp);
		resp.ignore(2);
		resp >> *attr_Velocity_A_read;
		attr.set_value(attr_Velocity_A_read);
	} catch(Tango::DevFailed) {
		attr.set_quality(Tango::ATTR_INVALID);
	}

	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Velocity_A
}
//--------------------------------------------------------
/**
 *	Write attribute Velocity_A related method
 *	Description: A Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Velocity_A(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Velocity_A(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Velocity_A) ENABLED START -----*/

	stringstream cmd2;
	try {
		cmd2 << "VEL A " << w_val << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}

	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Velocity_A
}
//--------------------------------------------------------
/**
 *	Read attribute Velocity_B related method
 *	Description: B Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Velocity_B(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Velocity_B(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Velocity_B) ENABLED START -----*/

	stringstream cmd, resp;
	cmd << "VEL? B\n";
	try {
		request(cmd, &resp);
		resp.ignore(2);
		resp >> *attr_Velocity_B_read;
		attr.set_value(attr_Velocity_B_read);
	} catch(Tango::DevFailed) {
		attr.set_quality(Tango::ATTR_INVALID);
	}

	//	Set the attribute value
	//attr.set_value(attr_Velocity_B_read);
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Velocity_B
}
//--------------------------------------------------------
/**
 *	Write attribute Velocity_B related method
 *	Description: B Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Velocity_B(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Velocity_B(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Velocity_B) ENABLED START -----*/

	stringstream cmd2;
	try {
		cmd2 << "VEL B " << w_val << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Velocity_B
}
//--------------------------------------------------------
/**
 *	Read attribute Velocity_C related method
 *	Description: C Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::read_Velocity_C(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Pie517::read_Velocity_C(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Pie517::read_Velocity_C) ENABLED START -----*/

	stringstream cmd, resp;
	cmd << "VEL? C\n";
	try {
		request(cmd, &resp);
		resp.ignore(2);
		resp >> *attr_Velocity_C_read;
		attr.set_value(attr_Velocity_C_read);
	} catch(Tango::DevFailed) {
		attr.set_quality(Tango::ATTR_INVALID);
	}

	/*----- PROTECTED REGION END -----*/	//	Pie517::read_Velocity_C
}
//--------------------------------------------------------
/**
 *	Write attribute Velocity_C related method
 *	Description: C Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Pie517::write_Velocity_C(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Pie517::write_Velocity_C(Tango::WAttribute &attr) entering... " << endl;
	//	Retrieve write value
	Tango::DevDouble	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Pie517::write_Velocity_C) ENABLED START -----*/

	stringstream cmd2;
	try {
		cmd2 << "VEL C " << w_val << "\n";
		request(cmd2);
	} catch(Tango::DevFailed) {
		throw;
	}
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::write_Velocity_C
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Pie517::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Pie517::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command Stop related method
 *	Description: execute stop command on X and Y axis
 *
 */
//--------------------------------------------------------
void Pie517::stop()
{
	DEBUG_STREAM << "Pie517::Stop()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pie517::stop) ENABLED START -----*/
	
	//	Add your own code to control device here
	try {
		stringstream cmd;
		//	cmd << "HLT\n"; // Smoothly
			cmd << "STP\n"; // Roughly
			request(cmd);
	} catch (...) {
	}

	/*----- PROTECTED REGION END -----*/	//	Pie517::stop
}
//--------------------------------------------------------
/**
 *	Command Reboot related method
 *	Description: Reboot the piezo
 *
 */
//--------------------------------------------------------
void Pie517::reboot()
{
	DEBUG_STREAM << "Pie517::Reboot()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Pie517::reboot) ENABLED START -----*/
	
	//	Add your own code to control device here
	stringstream cmd;
	cmd << "RBT\n";

	// Device will reboot immediatly so no way to read error code or any other
	// replies which are instead both read by request(). Thus I directly send
	// the command through socket object and reset connection.
	(void)socket->send_all(cmd);
	usleep(USECWAIT);

	initialized = false;
	socket->disconnect();

	/*----- PROTECTED REGION END -----*/	//	Pie517::reboot
}

/*----- PROTECTED REGION ID(Pie517::namespace_ending) ENABLED START -----*/

//	Additional Methods
/*
void Pie517::check_ranges(char AxisID, Tango::DevDouble value) {
	stringstream str;
	Tango::DevDouble min, max;

	switch (AxisID) {
		case 'X':
			min = min_Position_X;
			max = max_Position_X;
			break;
		case 'Y':
			min = min_Position_Y;
			max = max_Position_Y;
			break;
	}

	if (value < min_Position_X || value > max_Position_X) {
		str << "Out of range! Min " << min << " Max: " << max << ".";
		Tango::Except::throw_exception (
			(const char *)"ERROR",
			"Out of range!",
			str.str().c_str());
	}
}
*/
void Pie517::request(const std::stringstream& command_to_send, std::stringstream *possible_response) {
	int ret = -1; /* COM_ERROR */
	unsigned int p;
	stringstream errcmd, errcode;
	comm_ok = true;
	
	#ifdef _DBG_REQUEST
 		cout << "Sending command: " << command_to_send.str() << endl;
	#endif /* _DBG_REQUEST */

	p = socket->send_all(command_to_send);
	if (p != command_to_send.str().size())
		goto error;

	usleep(USECWAIT);

	if (possible_response != NULL) {
		if (socket->read_until(*possible_response, '\n') == false)
			goto error;
		#ifdef _DBG_REQUEST
	 		cout << "Received: " << possible_response->str() << endl;
		#endif /* _DBG_REQUEST */
	}

	errcmd << "ERR?\n";
	p = socket->send_all(errcmd);
	if (p != errcmd.str().size())
		goto error;

	usleep(USECWAIT);
		
	if (socket->read_until(errcode, '\n') == false)
		goto error;

	errcode >> ret;

	if (ret != 0) 
		goto error;

	return;

error:
	#ifdef _DBG_REQUEST
		cout << "Socket error, signal occurs or timeout expired! Error code: " << errcode.str() << " Command: " << command_to_send.str();
	#endif /* _DBG_REQUEST */

	comm_ok = false;
	socket->disconnect();
	Tango::Except::throw_exception (
		(const char *)"ERROR",
		errcode.str().c_str(),
		command_to_send.str().c_str());
}

// //--------------------------------------------------------
// /**
//  *	Command Homing related method
//  *	Description: Execute homing (Go_home command) on X and Y axis
//  *
//  */
// //--------------------------------------------------------
// void Pie517::homing()
// {
// 	DEBUG_STREAM << "Pie517::Homing()  - " << device_name << endl;
// 	
// 	//	Add your own code to control device here
// 	stringstream cmd;
// 	cmd << "GOH\n";
// 	request(cmd);
// }


/*----- PROTECTED REGION END -----*/	//	Pie517::namespace_ending
} //	namespace
