/*----- PROTECTED REGION ID(Pie517.h) ENABLED START -----*/
//=============================================================================
//
// file :        Pie517.h
//
// description : Include file for the Pie517 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Pie517_H
#define Pie517_H

#include <tango.h>
#include "mysocket.h"





/*----- PROTECTED REGION END -----*/	//	Pie517.h

/**
 *  Pie517 class description:
 *    
 */

namespace Pie517_ns
{
/*----- PROTECTED REGION ID(Pie517::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Pie517::Additional Class Declarations

class Pie517 : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Pie517::Data Members) ENABLED START -----*/

//	Add your own data members
public:
		Tango::DevDouble min_Position_X, max_Position_X;
		Tango::DevDouble min_Position_Y, max_Position_Y;

	bool comm_ok;


/*----- PROTECTED REGION END -----*/	//	Pie517::Data Members

//	Device property data members
public:
	//	IPAddress:	Piezo`s IP Address
	string	iPAddress;
	//	MQ_A:	M
	//  Q
	//  
	//  pos = M * Volt_A + Q
	vector<Tango::DevDouble>	mQ_A;
	//	MQ_B:	M
	//  Q
	//  
	//  pos = M * Volt_B + Q
	vector<Tango::DevDouble>	mQ_B;
	//	MQ_C:	M
	//  Q
	//  
	//  pos = M * Volt_C + Q
	vector<Tango::DevDouble>	mQ_C;

//	Attribute data members
public:
	Tango::DevDouble	*attr_Position_A_read;
	Tango::DevDouble	*attr_Position_B_read;
	Tango::DevDouble	*attr_Position_C_read;
	Tango::DevDouble	*attr_Volt_A_read;
	Tango::DevDouble	*attr_Volt_B_read;
	Tango::DevDouble	*attr_Volt_C_read;
	Tango::DevDouble	*attr_Velocity_A_read;
	Tango::DevDouble	*attr_Velocity_B_read;
	Tango::DevDouble	*attr_Velocity_C_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Pie517(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Pie517(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Pie517(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */	
	~Pie517() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Pie517::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Pie517::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Position_A related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Position_A(Tango::Attribute &attr);
	virtual void write_Position_A(Tango::WAttribute &attr);
	virtual bool is_Position_A_allowed(Tango::AttReqType type);
/**
 *	Attribute Position_B related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Position_B(Tango::Attribute &attr);
	virtual void write_Position_B(Tango::WAttribute &attr);
	virtual bool is_Position_B_allowed(Tango::AttReqType type);
/**
 *	Attribute Position_C related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Position_C(Tango::Attribute &attr);
	virtual void write_Position_C(Tango::WAttribute &attr);
	virtual bool is_Position_C_allowed(Tango::AttReqType type);
/**
 *	Attribute Volt_A related methods
 *	Description: Ch A, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Volt_A(Tango::Attribute &attr);
	virtual void write_Volt_A(Tango::WAttribute &attr);
	virtual bool is_Volt_A_allowed(Tango::AttReqType type);
/**
 *	Attribute Volt_B related methods
 *	Description: Ch B, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Volt_B(Tango::Attribute &attr);
	virtual void write_Volt_B(Tango::WAttribute &attr);
	virtual bool is_Volt_B_allowed(Tango::AttReqType type);
/**
 *	Attribute Volt_C related methods
 *	Description: Ch C, volt
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Volt_C(Tango::Attribute &attr);
	virtual void write_Volt_C(Tango::WAttribute &attr);
	virtual bool is_Volt_C_allowed(Tango::AttReqType type);
/**
 *	Attribute Velocity_A related methods
 *	Description: A Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Velocity_A(Tango::Attribute &attr);
	virtual void write_Velocity_A(Tango::WAttribute &attr);
	virtual bool is_Velocity_A_allowed(Tango::AttReqType type);
/**
 *	Attribute Velocity_B related methods
 *	Description: B Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Velocity_B(Tango::Attribute &attr);
	virtual void write_Velocity_B(Tango::WAttribute &attr);
	virtual bool is_Velocity_B_allowed(Tango::AttReqType type);
/**
 *	Attribute Velocity_C related methods
 *	Description: C Velocity
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Velocity_C(Tango::Attribute &attr);
	virtual void write_Velocity_C(Tango::WAttribute &attr);
	virtual bool is_Velocity_C_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Pie517::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();



//	Command related methods
public:
	/**
	 *	Command Stop related method
	 *	Description: execute stop command on X and Y axis
	 *
	 */
	virtual void stop();
	virtual bool is_Stop_allowed(const CORBA::Any &any);
	/**
	 *	Command Reboot related method
	 *	Description: Reboot the piezo
	 *
	 */
	virtual void reboot();
	virtual bool is_Reboot_allowed(const CORBA::Any &any);


/*----- PROTECTED REGION ID(Pie517::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
protected :	
	class mysocket_ns::MySocket *socket;
	void request(const std::stringstream& command_to_send, std::stringstream *possible_response = NULL);
//	void check_ranges(char AxisID, Tango::DevDouble value);
	bool initialized;

/*----- PROTECTED REGION END -----*/	//	Pie517::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Pie517::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Pie517::Additional Classes Definitions

}	//	End of namespace

#endif   //	Pie517_H
