/*----- PROTECTED REGION ID(Pie517Class.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Pie517Class.cpp
//
// description : C++ source for the Pie517Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Pie517 once per process.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Pie517Class.h>

/*----- PROTECTED REGION END -----*/	//	Pie517Class.cpp

//-------------------------------------------------------------------
/**
 *	Create Pie517Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Pie517_class(const char *name) {
		return Pie517_ns::Pie517Class::init(name);
	}
}

namespace Pie517_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Pie517Class *Pie517Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Pie517Class::Pie517Class(string &s)
 * description : 	constructor for the Pie517Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Pie517Class::Pie517Class(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering Pie517Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Pie517Class::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::constructor

	cout2 << "Leaving Pie517Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Pie517Class::~Pie517Class()
 * description : 	destructor for the Pie517Class
 */
//--------------------------------------------------------
Pie517Class::~Pie517Class()
{
	/*----- PROTECTED REGION ID(Pie517Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Pie517Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Pie517Class *Pie517Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Pie517Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Pie517Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Pie517Class *Pie517Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<Pie517 *>(device))->stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RebootClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RebootClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "RebootClass::execute(): arrived" << endl;
	((static_cast<Pie517 *>(device))->reboot());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Pie517Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Pie517Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Pie517Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Pie517Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Pie517Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Pie517Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Pie517Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Pie517Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "IPAddress";
	prop_desc = "Piezo`s IP Address";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MQ_A";
	prop_desc = "M\nQ\n\npos = M * Volt_A + Q";
	prop_def  = "1\n0";
	vect_data.clear();
	vect_data.push_back("1");
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MQ_B";
	prop_desc = "M\nQ\n\npos = M * Volt_B + Q";
	prop_def  = "1\n0";
	vect_data.clear();
	vect_data.push_back("1");
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MQ_C";
	prop_desc = "M\nQ\n\npos = M * Volt_C + Q";
	prop_def  = "1\n0";
	vect_data.clear();
	vect_data.push_back("1");
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : Pie517Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Pie517Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Pie517Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Pie517Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Pie517Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Pie517(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Pie517 *dev = static_cast<Pie517 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Pie517Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Pie517Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Pie517Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Pie517Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::attribute_factory_before
	//	Attribute : Position_A
	Position_AAttrib	*position_a = new Position_AAttrib();
	Tango::UserDefaultAttrProp	position_a_prop;
	//	description	not set for Position_A
	//	label	not set for Position_A
	position_a_prop.set_unit("um");
	position_a_prop.set_standard_unit("um");
	position_a_prop.set_display_unit("um");
	position_a_prop.set_format("%6.3f");
	//	max_value	not set for Position_A
	//	min_value	not set for Position_A
	//	max_alarm	not set for Position_A
	//	min_alarm	not set for Position_A
	//	max_warning	not set for Position_A
	//	min_warning	not set for Position_A
	//	delta_t	not set for Position_A
	//	delta_val	not set for Position_A
	
	position_a->set_default_properties(position_a_prop);
	//	Not Polled
	position_a->set_disp_level(Tango::OPERATOR);
	position_a->set_memorized();
	position_a->set_memorized_init(false);
	att_list.push_back(position_a);

	//	Attribute : Position_B
	Position_BAttrib	*position_b = new Position_BAttrib();
	Tango::UserDefaultAttrProp	position_b_prop;
	//	description	not set for Position_B
	//	label	not set for Position_B
	position_b_prop.set_unit("um");
	position_b_prop.set_standard_unit("um");
	position_b_prop.set_display_unit("um");
	position_b_prop.set_format("%6.3f");
	//	max_value	not set for Position_B
	//	min_value	not set for Position_B
	//	max_alarm	not set for Position_B
	//	min_alarm	not set for Position_B
	//	max_warning	not set for Position_B
	//	min_warning	not set for Position_B
	//	delta_t	not set for Position_B
	//	delta_val	not set for Position_B
	
	position_b->set_default_properties(position_b_prop);
	//	Not Polled
	position_b->set_disp_level(Tango::OPERATOR);
	position_b->set_memorized();
	position_b->set_memorized_init(false);
	att_list.push_back(position_b);

	//	Attribute : Position_C
	Position_CAttrib	*position_c = new Position_CAttrib();
	Tango::UserDefaultAttrProp	position_c_prop;
	//	description	not set for Position_C
	//	label	not set for Position_C
	position_c_prop.set_unit("um");
	position_c_prop.set_standard_unit("um");
	position_c_prop.set_display_unit("um");
	position_c_prop.set_format("%6.3f");
	//	max_value	not set for Position_C
	//	min_value	not set for Position_C
	//	max_alarm	not set for Position_C
	//	min_alarm	not set for Position_C
	//	max_warning	not set for Position_C
	//	min_warning	not set for Position_C
	//	delta_t	not set for Position_C
	//	delta_val	not set for Position_C
	
	position_c->set_default_properties(position_c_prop);
	//	Not Polled
	position_c->set_disp_level(Tango::OPERATOR);
	position_c->set_memorized();
	position_c->set_memorized_init(false);
	att_list.push_back(position_c);

	//	Attribute : Volt_A
	Volt_AAttrib	*volt_a = new Volt_AAttrib();
	Tango::UserDefaultAttrProp	volt_a_prop;
	volt_a_prop.set_description("Ch A, volt");
	//	label	not set for Volt_A
	volt_a_prop.set_unit("V");
	volt_a_prop.set_standard_unit("V");
	volt_a_prop.set_display_unit("V");
	volt_a_prop.set_format("%6.2f");
	//	max_value	not set for Volt_A
	//	min_value	not set for Volt_A
	//	max_alarm	not set for Volt_A
	//	min_alarm	not set for Volt_A
	//	max_warning	not set for Volt_A
	//	min_warning	not set for Volt_A
	//	delta_t	not set for Volt_A
	//	delta_val	not set for Volt_A
	
	volt_a->set_default_properties(volt_a_prop);
	volt_a->set_polling_period(1000);
	volt_a->set_disp_level(Tango::OPERATOR);
	volt_a->set_memorized();
	volt_a->set_memorized_init(false);
	att_list.push_back(volt_a);

	//	Attribute : Volt_B
	Volt_BAttrib	*volt_b = new Volt_BAttrib();
	Tango::UserDefaultAttrProp	volt_b_prop;
	volt_b_prop.set_description("Ch B, volt");
	//	label	not set for Volt_B
	volt_b_prop.set_unit("V");
	volt_b_prop.set_standard_unit("V");
	volt_b_prop.set_display_unit("%6.2f");
	//	format	not set for Volt_B
	//	max_value	not set for Volt_B
	//	min_value	not set for Volt_B
	//	max_alarm	not set for Volt_B
	//	min_alarm	not set for Volt_B
	//	max_warning	not set for Volt_B
	//	min_warning	not set for Volt_B
	//	delta_t	not set for Volt_B
	//	delta_val	not set for Volt_B
	
	volt_b->set_default_properties(volt_b_prop);
	volt_b->set_polling_period(1000);
	volt_b->set_disp_level(Tango::OPERATOR);
	volt_b->set_memorized();
	volt_b->set_memorized_init(false);
	att_list.push_back(volt_b);

	//	Attribute : Volt_C
	Volt_CAttrib	*volt_c = new Volt_CAttrib();
	Tango::UserDefaultAttrProp	volt_c_prop;
	volt_c_prop.set_description("Ch C, volt");
	//	label	not set for Volt_C
	volt_c_prop.set_unit("V");
	volt_c_prop.set_standard_unit("V");
	volt_c_prop.set_display_unit("V");
	volt_c_prop.set_format("%6.2f");
	//	max_value	not set for Volt_C
	//	min_value	not set for Volt_C
	//	max_alarm	not set for Volt_C
	//	min_alarm	not set for Volt_C
	//	max_warning	not set for Volt_C
	//	min_warning	not set for Volt_C
	//	delta_t	not set for Volt_C
	//	delta_val	not set for Volt_C
	
	volt_c->set_default_properties(volt_c_prop);
	volt_c->set_polling_period(1000);
	volt_c->set_disp_level(Tango::OPERATOR);
	volt_c->set_memorized();
	volt_c->set_memorized_init(false);
	att_list.push_back(volt_c);

	//	Attribute : Velocity_A
	Velocity_AAttrib	*velocity_a = new Velocity_AAttrib();
	Tango::UserDefaultAttrProp	velocity_a_prop;
	velocity_a_prop.set_description("A Velocity");
	//	label	not set for Velocity_A
	velocity_a_prop.set_unit("V/s");
	velocity_a_prop.set_standard_unit("V/s");
	velocity_a_prop.set_display_unit("V/s");
	velocity_a_prop.set_format("%6.2f");
	//	max_value	not set for Velocity_A
	//	min_value	not set for Velocity_A
	//	max_alarm	not set for Velocity_A
	//	min_alarm	not set for Velocity_A
	//	max_warning	not set for Velocity_A
	//	min_warning	not set for Velocity_A
	//	delta_t	not set for Velocity_A
	//	delta_val	not set for Velocity_A
	
	velocity_a->set_default_properties(velocity_a_prop);
	//	Not Polled
	velocity_a->set_disp_level(Tango::EXPERT);
	velocity_a->set_memorized();
	velocity_a->set_memorized_init(false);
	att_list.push_back(velocity_a);

	//	Attribute : Velocity_B
	Velocity_BAttrib	*velocity_b = new Velocity_BAttrib();
	Tango::UserDefaultAttrProp	velocity_b_prop;
	velocity_b_prop.set_description("B Velocity");
	//	label	not set for Velocity_B
	velocity_b_prop.set_unit("V/s");
	velocity_b_prop.set_standard_unit("V/s");
	velocity_b_prop.set_display_unit("V/s");
	velocity_b_prop.set_format("%6.2f");
	//	max_value	not set for Velocity_B
	//	min_value	not set for Velocity_B
	//	max_alarm	not set for Velocity_B
	//	min_alarm	not set for Velocity_B
	//	max_warning	not set for Velocity_B
	//	min_warning	not set for Velocity_B
	//	delta_t	not set for Velocity_B
	//	delta_val	not set for Velocity_B
	
	velocity_b->set_default_properties(velocity_b_prop);
	//	Not Polled
	velocity_b->set_disp_level(Tango::EXPERT);
	velocity_b->set_memorized();
	velocity_b->set_memorized_init(false);
	att_list.push_back(velocity_b);

	//	Attribute : Velocity_C
	Velocity_CAttrib	*velocity_c = new Velocity_CAttrib();
	Tango::UserDefaultAttrProp	velocity_c_prop;
	velocity_c_prop.set_description("C Velocity");
	//	label	not set for Velocity_C
	velocity_c_prop.set_unit("V/s");
	velocity_c_prop.set_standard_unit("V/s");
	velocity_c_prop.set_display_unit("V/s");
	velocity_c_prop.set_format("%6.2f");
	//	max_value	not set for Velocity_C
	//	min_value	not set for Velocity_C
	//	max_alarm	not set for Velocity_C
	//	min_alarm	not set for Velocity_C
	//	max_warning	not set for Velocity_C
	//	min_warning	not set for Velocity_C
	//	delta_t	not set for Velocity_C
	//	delta_val	not set for Velocity_C
	
	velocity_c->set_default_properties(velocity_c_prop);
	//	Not Polled
	velocity_c->set_disp_level(Tango::EXPERT);
	velocity_c->set_memorized();
	velocity_c->set_memorized_init(false);
	att_list.push_back(velocity_c);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Pie517Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Pie517Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Pie517Class::command_factory()
{
	/*----- PROTECTED REGION ID(Pie517Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::command_factory_before


	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	//	Command Reboot
	RebootClass	*pRebootCmd =
		new RebootClass("Reboot",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pRebootCmd);

	/*----- PROTECTED REGION ID(Pie517Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Pie517Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void Pie517Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Pie517Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Pie517Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Pie517Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Pie517 *dev = static_cast<Pie517 *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Pie517Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Pie517Class::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Pie517Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Pie517Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Pie517Class::Additional Methods
} //	namespace
