/*----- PROTECTED REGION ID(Pie517StateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Pie517StateMachine.cpp
//
// description : State machine file for the Pie517 class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: abrami $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <Pie517.h>

/*----- PROTECTED REGION END -----*/	//	Pie517::Pie517StateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  Piezo Ready
//  OFF      |  Piezo in disabled state
//  FAULT    |  Errors on socket connection
//  STANDBY  |  Piezo in not initialized state
//  MOVING   |  Piezo moving or homing


namespace Pie517_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Position_A_allowed()
 *	Description : Execution allowed for Position_A attribute
 */
//--------------------------------------------------------
bool Pie517::is_Position_A_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Position_A attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Position_AStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Position_AStateAllowed_WRITE

	//	Not any excluded states for Position_A attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Position_AStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Position_AStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Position_B_allowed()
 *	Description : Execution allowed for Position_B attribute
 */
//--------------------------------------------------------
bool Pie517::is_Position_B_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Position_B attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Position_BStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Position_BStateAllowed_WRITE

	//	Not any excluded states for Position_B attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Position_BStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Position_BStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Position_C_allowed()
 *	Description : Execution allowed for Position_C attribute
 */
//--------------------------------------------------------
bool Pie517::is_Position_C_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Position_C attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Position_CStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Position_CStateAllowed_WRITE

	//	Not any excluded states for Position_C attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Position_CStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Position_CStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Volt_A_allowed()
 *	Description : Execution allowed for Volt_A attribute
 */
//--------------------------------------------------------
bool Pie517::is_Volt_A_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Volt_A attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Volt_AStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Volt_AStateAllowed_WRITE

	//	Not any excluded states for Volt_A attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Volt_AStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Volt_AStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Volt_B_allowed()
 *	Description : Execution allowed for Volt_B attribute
 */
//--------------------------------------------------------
bool Pie517::is_Volt_B_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Volt_B attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Volt_BStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Volt_BStateAllowed_WRITE

	//	Not any excluded states for Volt_B attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Volt_BStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Volt_BStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Volt_C_allowed()
 *	Description : Execution allowed for Volt_C attribute
 */
//--------------------------------------------------------
bool Pie517::is_Volt_C_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Volt_C attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Volt_CStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Volt_CStateAllowed_WRITE

	//	Not any excluded states for Volt_C attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Volt_CStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Volt_CStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Velocity_A_allowed()
 *	Description : Execution allowed for Velocity_A attribute
 */
//--------------------------------------------------------
bool Pie517::is_Velocity_A_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Velocity_A attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Velocity_AStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Velocity_AStateAllowed_WRITE

	//	Not any excluded states for Velocity_A attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Velocity_AStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Velocity_AStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Velocity_B_allowed()
 *	Description : Execution allowed for Velocity_B attribute
 */
//--------------------------------------------------------
bool Pie517::is_Velocity_B_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Velocity_B attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Velocity_BStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Velocity_BStateAllowed_WRITE

	//	Not any excluded states for Velocity_B attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Velocity_BStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Velocity_BStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Velocity_C_allowed()
 *	Description : Execution allowed for Velocity_C attribute
 */
//--------------------------------------------------------
bool Pie517::is_Velocity_C_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Velocity_C attribute in Write access.
	/*----- PROTECTED REGION ID(Pie517::Velocity_CStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Velocity_CStateAllowed_WRITE

	//	Not any excluded states for Velocity_C attribute in read access.
	/*----- PROTECTED REGION ID(Pie517::Velocity_CStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::Velocity_CStateAllowed_READ
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Stop_allowed()
 *	Description : Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool Pie517::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(Pie517::StopStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : Pie517::is_Reboot_allowed()
 *	Description : Execution allowed for Reboot attribute
 */
//--------------------------------------------------------
bool Pie517::is_Reboot_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reboot command.
	/*----- PROTECTED REGION ID(Pie517::RebootStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Pie517::RebootStateAllowed
	return true;
}

}	//	End of namespace
